Redmine - Defect #25634

Highlight language aliases are no more supported
2017-04-18 13:21 - Benoit Zugmeyer

Status: Closed Start date:

Priority: High Due date:

Assignee: Jean-Philippe Lang % Done: 0%
Category: Text formatting Estimated time: 0.00 hour
Target version: 3.2.7

Resolution: Fixed Affected version: 3.2.6

Description

Following r16501 (released in Redmine 3.3.3), highlight language aliases (the "map" property declared in
coderay-1.1.1/lib/coderay/scanners/_map.rb ) are not taken into account when checking if a language is supported.

We used to write code snippets with code class="javascript" , but since the true JavaScript coderay scanner is called java_script.rb,
all our JS snippets aren't highlighted anymore.

Related issues:
Related to Redmine - Defect #26055: Three issues with Redmine::SyntaxHighligh... Closed

Associated revisions

Revision 16568 - 2017-05-27 09:53 - Jean-Philippe Lang
Highlight language aliases are no more supported (#25634).

Patch by Go MAEDA.

Revision 16570 - 2017-05-27 10:36 - Jean-Philippe Lang
Merged r16568 (#25634).

Revision 16571 - 2017-05-27 10:36 - Jean-Philippe Lang
Merged r16568 (#25634).

History

#1 - 2017-04-24 04:34 - Go MAEDA

- File 25634-r16501.png added

- File 25634-r16502.png added

- Category changed from Wiki to Text formatting
- Status changed from New to Confirmed

- Priority changed from Normal to High

- Target version set to 3.2.7

- Affected version changed from 3.3.3 to 3.2.6

Confirmed in trunk. r16502 have broken syntax highlighting.

r16501 (good):

Description

function getRelationsArray() {
var arr = new Array();
$.each($( div.task_todo[data-rels]'), function({index_div, element) {
var element_id = $(element).attr("id");
if (element_id I= null) {
var issue id = element_id.replace("task-todo-issue-", "");
var data_rels = $(element).data("rels");
for (rel_type_key in data_rels) {
$.each({data_rels[rel_type_key], function(index_ issue, element_issue) {
arr.push({issuve_from: issue_id, issue to: element_issue,
rel_type: rel type _key});
¥
https://www.redmine.org/projects/redmine/repository/svn/revisions/16501
https://www.redmine.org/projects/redmine/repository/svn/revisions/16502
16502 (bad):

Description

function getRelationsArray() {
var arr = new Array();
f$.each($('div.task_todo[data-rels]’), function(index div, element) {
var element_id = $(element).attr("id");
if (element_id != null) {
var issue_id = element_id.replace("task-todo-issue-", "");
var data_rels = $(element).data("rels");
for (rel_type_key in data_rels) {
%.each(data_rels[rel_type_key], function(index_issue, element_issue) {
arr.push({issue_from: issue_id, issue_to: element_issue,
rel_type: rel_type_key});

});

#2 - 2017-04-24 05:58 - Go MAEDA
This problem is due to Redmine::SyntaxHighlighting::CodeRay::language_supported?.

def language_supported? (language)

::CodeRay: :Scanners.list.include? (language.to_s.downcase.to_sym)

rescue
false
end
p language
# => "javascript"
p ::CodeRay::Scanners.list
# => [:c, :clojure, ... :java_script, ... :xml, :yaml]
p ::CodeRay::Scanners.list.include? (language.to_s.downcase.to_sym)
# => false

#3 - 2017-04-24 08:19 - Mischa The Evil

Here is a quick and dirty workaround (which | haven't actually tested yet) for users who are suffering from this regression and cannot wait for a
released fix:

Index: lib/redmine/syntax_highlighting.rb

-—— lib/redmine/syntax_highlighting.rb (revision 16543)

+++ lib/redmine/syntax_highlighting.rb (working copy)
@@ -70,7 +70,8 @@

8

’

+

end

def language_supported? (language)
::CodeRay: :Scanners.list.include? (language.to_s.downcase.to_sym)
coderay_aliases = [:'c++', :cplusplus, :ecmascript, :ecma_script,
:js, :pascal, :patch, :plain, :plaintext, :xhtml, :yml]
::CodeRay: :Scanners.list.include? (language.to_s.downcase.to_sym)

ge.to_s.downcase.to_sym)

rescue
false
end

#4 - 2017-05-20 08:46 - Go MAEDA
- File fix-defect-25634.diff added

This is a patch to fix this issue.

#5 - 2017-05-20 09:14 - Go MAEDA
- File deleted (fix-defect-25634.diff)

#6 - 2017-05-20 09:15 - Go MAEDA
- File fix-defect-25634.diff added

Slightly improved the patch.
https://www.redmine.org/projects/redmine/repository/svn/revisions/16502

#7 - 2017-05-26 13:34 - Holger Just

Thanks for the patch. | had indeed missed the alias names for Coderay.

Looks good to me!

#8 - 2017-05-27 09:53 - Jean-Philippe Lang
- Status changed from Confirmed to Resolved
- Assignee set to Jean-Philippe Lang

- Resolution set to Fixed

Patch committed, thanks.

#9 - 2017-05-27 10:36 - Jean-Philippe Lang

- Status changed from Resolved to Closed

#10 - 2017-05-28 15:43 - Mischa The Evil
- Related to Defect #26055: Three issues with Redmine::SyntaxHighlighting::CodeRay.language_supported? added

#11 - 2017-05-28 15:44 - Mischa The Evil

- Status changed from Closed to Reopened

Reopened in light of #26055.

#12 - 2017-06-07 21:35 - Jean-Philippe Lang

- Status changed from Reopened to Closed

Files

25634-r16501.png 42.9 KB 2017-04-24 Go MAEDA
25634-r16502.png 38.9 KB 2017-04-24 Go MAEDA
fix-defect-25634.diff 1.64 KB 2017-05-20 Go MAEDA
